<?xml version="1.0"?>
<ruleset name="Sapphire">
    <file>app</file>
    <file>tests</file>

    <exclude-pattern>app/Console</exclude-pattern>
    <exclude-pattern>app/Exceptions/Handler.php</exclude-pattern>
    <exclude-pattern>app/Http/Kernel.php</exclude-pattern>
    <exclude-pattern>app/Http/Controllers/Controller.php</exclude-pattern>
    <exclude-pattern>app/Http/Controllers/Auth</exclude-pattern>
    <exclude-pattern>app/Http/Middleware</exclude-pattern>
    <exclude-pattern>app/Providers</exclude-pattern>

    <arg name="parallel" value="75"/>

    <rule ref="PSR2"/>

    <rule ref="PSR1.Methods.CamelCapsMethodName">
        <exclude-pattern>tests</exclude-pattern>
    </rule>

    <rule ref="vendor/slevomat/coding-standard/SlevomatCodingStandard/ruleset.xml">
        <exclude name="SlevomatCodingStandard.Classes.SuperfluousExceptionNaming"/>
        <exclude name="SlevomatCodingStandard.Commenting.DisallowOneLinePropertyDocComment"/>
        <exclude name="SlevomatCodingStandard.ControlStructures.RequireYodaComparison"/>
        <exclude name="SlevomatCodingStandard.Files.TypeNameMatchesFileName"/>
        <exclude name="SlevomatCodingStandard.Functions.TrailingCommaInCall"/>
        <exclude name="SlevomatCodingStandard.Generic.Files.LineEndingsSniff"/>
        <exclude name="SlevomatCodingStandard.Namespaces.UseOnlyWhitelistedNamespaces"/>
        <exclude name="SlevomatCodingStandard.Namespaces.FullyQualifiedExceptions"/>
        <exclude name="SlevomatCodingStandard.Namespaces.FullyQualifiedGlobalConstants"/>
        <exclude name="SlevomatCodingStandard.Namespaces.FullyQualifiedGlobalFunctions"/>
    </rule>

    <rule ref="SlevomatCodingStandard.Classes.TraitUseSpacing">
        <properties>
            <property name="linesCountBeforeFirstUse" value="0"/>
        </properties>

        <exclude-pattern>tests</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.Classes.EmptyLinesAroundClassBraces">
        <properties>
            <property name="linesCountAfterOpeningBrace" value="0"/>
            <property name="linesCountBeforeClosingBrace" value="0"/>
        </properties>
    </rule>

    <rule ref="SlevomatCodingStandard.Commenting.EmptyComment">
        <exclude-pattern>app/Contracts/Repositories</exclude-pattern>
        <exclude-pattern>app/Exceptions</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.Commenting.ForbiddenComments">
        <properties>
            <property name="forbiddenCommentPatterns" type="array">
                <element value="/\w+\s{1}constructor\./"/>
            </property>
        </properties>

        <exclude-pattern>tests</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.Commenting.ForbiddenAnnotations">
        <properties>
            <property name="forbiddenAnnotations" type="array">
                <element value="@throws"/>
            </property>
        </properties>

        <exclude-pattern>tests</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.Functions.UnusedParameter">
        <exclude-pattern>app/Criteria</exclude-pattern>
        <exclude-pattern>app/Http/Resources</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.Namespaces.ReferenceUsedNamesOnly">
        <properties>
            <property name="allowFullyQualifiedNameForCollidingClasses" value="true"/>
        </properties>
    </rule>

    <rule ref="SlevomatCodingStandard.TypeHints.DisallowMixedTypeHint">
        <exclude-pattern>app/Contracts/ValueObject.php</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.TypeHints.TypeHintDeclaration">
        <properties>
            <property name="allAnnotationsAreUseful" value="true"/>
        </properties>
    </rule>

    <rule ref="SlevomatCodingStandard.TypeHints.TypeHintDeclaration.MissingParameterTypeHint">
        <exclude-pattern>app/Criteria</exclude-pattern>
        <exclude-pattern>app/Http/Resources</exclude-pattern>
        <exclude-pattern>tests/CreatesApplication.php</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.TypeHints.TypeHintDeclaration.MissingReturnTypeHint">
        <exclude-pattern>app/Contracts/Interactions</exclude-pattern>
        <exclude-pattern>tests/CreatesApplication.php</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.TypeHints.TypeHintDeclaration.MissingTraversableParameterTypeHintSpecification">
        <exclude-pattern>tests</exclude-pattern>
    </rule>

    <rule ref="SlevomatCodingStandard.TypeHints.TypeHintDeclaration.MissingTraversableReturnTypeHintSpecification">
        <exclude-pattern>tests</exclude-pattern>
    </rule>
</ruleset>